

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;

import java.applet.Applet;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.BorderLayout;


import com.sun.j3d.loaders.objectfile.ObjectFile;
import com.sun.j3d.loaders.ParsingErrorException;
import com.sun.j3d.loaders.IncorrectFormatException;
import com.sun.j3d.loaders.Scene;

import java.awt.GraphicsConfiguration;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import javax.vecmath.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 * MouseZoom is a Java3D behavior object that lets users control the 
 * Z axis translation of an object via a mouse drag motion with the second
 * mouse button. See MouseRotate for similar usage info.
 */
 
public class MyMouseZoom extends MouseBehavior {
    double z_factor = .04;
	double factor = 0.7*0.025;
    Vector3d translation = new Vector3d();
	ImageText z;
  
  private MouseBehaviorCallback callback = null;

  /**
   * Creates a zoom behavior given the transform group.
   * @param transformGroup The transformGroup to operate on.
   */
  public MyMouseZoom(TransformGroup transformGroup) {
    super(transformGroup);
  }

  /**
   * Creates a default mouse zoom behavior.
   **/
  public MyMouseZoom(){
    super(0);
  }

  /**
   * Creates a zoom behavior.
   * Note that this behavior still needs a transform
   * group to work on (use setTransformGroup(tg)) and
   * the transform group must add this behavior.
   * @param flags
   */
  public MyMouseZoom(int flags) {
      super(flags);
   }

  public void initialize() {
    super.initialize();
    if ((flags & INVERT_INPUT) == INVERT_INPUT) {
       z_factor *= -1;
       invert = true;
    }
  }

  /**
   * Return the y-axis movement multipler.
   **/
  
  public double getFactor() {
    return z_factor;
  }
  
  /**
   * Set the y-axis movement multipler with factor.
   **/
  
  public void setFactor( double factor) {
    z_factor = factor;
    
  }
  
  public void processStimulus (Enumeration criteria) {
    WakeupCriterion wakeup;
    AWTEvent[] event;
    int id;
    int dx, dy;
    
    while (criteria.hasMoreElements()) {
      wakeup = (WakeupCriterion) criteria.nextElement();
      if (wakeup instanceof WakeupOnAWTEvent) {
	event = ((WakeupOnAWTEvent)wakeup).getAWTEvent();
	for (int i=0; i<event.length; i++) { 
	  processMouseEvent((MouseEvent) event[i]);
	  
	  if (((buttonPress)&&((flags & MANUAL_WAKEUP) == 0)) ||
	      ((wakeUp)&&((flags & MANUAL_WAKEUP) != 0))){
	    id = event[i].getID();
	    if ((id == MouseEvent.MOUSE_DRAGGED) &&
		((MouseEvent)event[i]).isAltDown() && 
		!((MouseEvent)event[i]).isMetaDown()){
	      
	      
	      x = ((MouseEvent)event[i]).getX();
	      y = ((MouseEvent)event[i]).getY();
	      
	      dx = x - x_last;
	      dy = y - y_last;
	      
	      if (!reset){
		transformGroup.getTransform(currXform);
		
		
		translation.z  = dy*z_factor;
		z.val += translation.z/factor;
		z.setText(Double.toString(z.val));
		
		transformX.set(translation);
		
		if (invert) {
		  currXform.mul(currXform, transformX);
		} else {
		  currXform.mul(transformX, currXform);
		}
		
		transformGroup.setTransform(currXform);

		transformChanged( currXform );

                if (callback!=null)
                    callback.transformChanged( MouseBehaviorCallback.TRANSLATE,
                                               currXform );

	      }
	      else {
		reset = false;
	      }
	      
	      x_last = x;
	      y_last = y;
	    }
	    else if (id == MouseEvent.MOUSE_PRESSED) {
	      x_last = ((MouseEvent)event[i]).getX();
	      y_last = ((MouseEvent)event[i]).getY();
	    }
	  }
	}
      }
    }
    
    wakeupOn (mouseCriterion);
  }
  /**
    * Users can overload this method  which is called every time
    * the Behavior updates the transform
    *
    * Default implementation does nothing
    */
  public void transformChanged( Transform3D transform ) {
  }
 
  /**
    * The transformChanged method in the callback class will
    * be called every time the transform is updated
    */
  public void setupCallback( MouseBehaviorCallback callback ) {
      this.callback = callback;
  }
}

