import java.io.*;
import java.awt.*;
import java.text.*;
import java.awt.image.BufferedImage;
import javax.media.j3d.*;
import com.sun.image.codec.jpeg.*;
import sun.awt.image.codec.*;

public class TimeCanvas3D extends Canvas3D {
    public ImageText imagex, imagey;
	public String fileName;
	public double quality;
	public boolean flag;
    GraphicsContext3D gc;
    XRenderer renderer;
	boolean saveFrame = false;
    NumberFormat nf;
    long frameCount = 0;
    double lastTime = System.currentTimeMillis();
    
    public TimeCanvas3D (GraphicsConfiguration g) {
       this (g,null);
       }


    public TimeCanvas3D (GraphicsConfiguration g, XRenderer xr) {
       super(g);
       renderer = xr;
       gc = getGraphicsContext3D();
       //nf = NumberFormat.getInstance();
       //nf.setMaximumFractionDigits(2);
       }
    //NumberFormat nf;


    String saveFileName = null;

    public void saveFrames(String filename, double qualit) {
	   fileName = filename;
	   quality = qualit;
	   flag = true;
	}
    public void saveFrame(String fileName, double quality) {
       saveFileName = fileName;
       saveFrame = true;
	   //System.out.println("save in c");
	   writeImage(saveFileName,getCanvasImage(),quality);
	   //System.out.println("save done in c");
	   if(renderer != null)renderer.postSwap(gc);
	   //System.out.println("save");
       }


    public void saveFrame() {
       saveFrame = true;
       }

     double t1, // system time when 1st render is called
            t2;
     int renderCt = 0,
         renderInx = 0;
     double[] last20 = new double[20];

     public double[] getLast20 ()        { return last20; }
     public double getRenderStartTime () { return t1; }
     public int getRenderCt ()           { return renderCt; }
     public int getRenderInx ()          { return renderInx; }
     public void resetRenderCt ()        { renderCt = 0; }

     Thread tStats = null;
     boolean tStatsStop = false;



    public void postSwap() {
	   //System.out.println("swap");
	   imagex.setText(Integer.toString(getSize().width));
	   imagey.setText(Integer.toString(getSize().height));
	   imagex.setValue(getSize().width);
	   imagey.setValue(getSize().height);
       if (renderer != null)
          renderer.postSwap (gc);
       if(flag)saveFrame(fileName,quality);
	   //getParent().getParent().notifyAll();
       }

   public BufferedImage  getCanvasImage () {
       GraphicsContext3D  ctx = getGraphicsContext3D();
       Raster ras = new Raster();
       ras.setType (Raster.RASTER_COLOR);
       ras.setCapability (Raster.ALLOW_IMAGE_READ);
       Dimension d = getSize();
       ras.setSize (d);
       ras.setImage (new ImageComponent2D(ImageComponent2D.FORMAT_RGB,
                                          d.width, d.height));

       ctx.readRaster(ras);
       // Now strip out the image info
       ImageComponent2D img_src = ras.getImage();
//       DepthComponent depth = ras.getDepthComponent();
       //System.out.println("done in getcanvasimage()");
       return img_src.getImage();
       }


   public void writeImage (String fileName, BufferedImage bi, double quality) {
      try {
         //createDir (fileName);
         File file = new File(fileName);
         FileOutputStream out = new FileOutputStream(file);
         JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(out);
         JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam(bi);
         param.setQuality(((float)quality), false);
         encoder.setJPEGEncodeParam(param);
         encoder.encode(bi);
         out.close();
		 //System.out.println("done write image to file");
         }
      catch (Exception ex) {
         System.out.println ("Error writing image to file " + fileName +
                             ": " + ex.toString());
         ex.printStackTrace();
         }
      }

   public boolean createDir (String fileName) {
      int i = fileName.lastIndexOf ('\\');
      if (i > -1) {
         String dir = fileName.substring (0, i);
         File f = new File (dir);
         return f.mkdirs(); // creates all dirs in file's pathname
     //    System.out.println ("mkdirs on: " + dir +"; rc = " + b);
         }
      return true;
      }


    public void preRender () {
       renderCt++;
       if (renderCt == 1)
          t1 = System.currentTimeMillis();
       else {
          last20[renderInx++] = System.currentTimeMillis();
          if (renderInx == last20.length)
             renderInx = 0;
          }
       if (renderer != null)
          renderer.preRender (gc);
       }

    public void postRender () {
       if (renderer != null)
          renderer.postRender (gc);
       }


    public void renderField(int fieldDesc) {
       if (renderer != null)
          renderer.renderField (fieldDesc, gc);
       }

    }  // end class TimeCanvas3D

