//define the structure of the asf structure data
import java.awt.*;
import java.io.*;
import java.util.*;
import java.applet.*;
import java.net.*;
import javax.vecmath.*;
import javax.media.j3d.*;
import java.lang.*;
import java.lang.Math;


public class asf_struct{
  Matrix mat;
  String name;
  int sons[];
  int number_son;
  int order[];
  int frame_num;
  float ab_pos[];
  float position[];
  float orientation[];
  float direction[];
  float dir_front_up[];
  float dir_back_down[];
  float dir_roottonode_left[];
  float dir_roottonode_right[];
  float length;
  int number_dof;
  int dof[];
  int root;
  float axis[];
  float dofc[][];
  float amc_position[][];
  float pos_front_up[][];
  float pos_back_down[][];
  float pos_roottonode_left[][];
  float pos_roottonode_right[][];

  asf_struct(){
    mat = new Matrix();
	mat.makeIdent();
    number_son = 0;
	root = 0;
    order = new int[6];
	ab_pos = new float[3];
    position = new float[3];
    orientation = new float[3];
    direction = new float[3];
	dir_front_up = new float[3];
	dir_back_down = new float[3];
	dir_roottonode_left = new float[3];
	dir_roottonode_right = new float[3];
	axis = new float[3];
    dof = new int[6];
	number_dof = 0;
	  for(int i=0;i<6;i++)
	  {
	   order[i] = 0;
	   dof[i] = 0;
	   }
  }

  public void calcasfdata(asf_struct[] joints)
  {
    //System.out.println(number_son);
    for(int i=0;i<number_son;i++)
	{
		for(int j=0;j<3;j++)
		 joints[sons[i]].ab_pos[j] = ab_pos[j]+(joints[sons[i]].direction[j])*(joints[sons[i]].length);
	}

	int i,j,k;
    float pos[] = new float[3];
	float new_pos[] = new float[3];
    for(i=0;i<number_son;i++)
	{
		Matrix mat1 = new Matrix();
		mat1.makeIdent();
		Matrix mat1inv = new Matrix();
		mat1inv.makeIdent();

		mat1.postRotX(joints[sons[i]].axis[0]);
		mat1.postRotY(joints[sons[i]].axis[1]);
		mat1.postRotZ(joints[sons[i]].axis[2]);
		mat1inv.postMult(mat1);
		mat1inv.invert();

		
		for(j=0;j<3;j++)
		  pos[j] = (joints[sons[i]].direction[j])*(joints[sons[i]].length);
		new_pos = mat1inv.xformPt(pos);
		Vector3f dir = new Vector3f(new_pos[0],new_pos[1],new_pos[2]);
		Vector3f z = new Vector3f(0,0,1);
		Vector3f y = new Vector3f(0,1,0);

		y.cross(dir,z);
		z.cross(y,dir);
		y.normalize();
		z.normalize();

		float dirr[] = new float[3];
		float zz[] = new float[3];
		float yy[] = new float[3];

		dirr[0] = dir.x;
		dirr[1] = dir.y;
		dirr[2] = dir.z;

		zz[0] = z.x;
		zz[1] = z.y;
		zz[2] = z.z;

		yy[0] = y.x;
		yy[1] = y.y;
		yy[2] = y.z;

		for(j=0;j<3;j++)
		{
		joints[sons[i]].dir_front_up[j] = 0.4f*dirr[j] + 0.1f*joints[sons[i]].length*zz[j];
		joints[sons[i]].dir_back_down[j] = 0.4f*dirr[j] - 0.1f*joints[sons[i]].length*zz[j];
		joints[sons[i]].dir_roottonode_left[j] = 0.4f*dirr[j] - 0.1f*joints[sons[i]].length*yy[j];
		joints[sons[i]].dir_roottonode_right[j] = 0.4f*dirr[j] + 0.1f*joints[sons[i]].length*yy[j];
		}
		joints[sons[i]].dir_front_up = mat1.xformPt(joints[sons[i]].dir_front_up);
		joints[sons[i]].dir_back_down = mat1.xformPt(joints[sons[i]].dir_back_down);
		joints[sons[i]].dir_roottonode_left = mat1.xformPt(joints[sons[i]].dir_roottonode_left);
		joints[sons[i]].dir_roottonode_right = mat1.xformPt(joints[sons[i]].dir_roottonode_right);
	}

	for(i=0;i<number_son;i++)
	   joints[sons[i]].calcasfdata(joints);
	
  }

  public void calcamcdata(asf_struct[] joints,int frame)
  {
    int i,j,k;
    float pos[] = new float[3];
	if(number_son==3&&frame==0)
	{
		try {
		File outputFile = new File("debug2.txt");
		FileWriter out1 = new FileWriter(outputFile);
		for(j=0;j<number_son;j++)
			 {
				out1.write(joints[sons[j]].name);
				out1.write("\r");
				
				String temp1=null;
				for(k=0;k<6;k++)
				{
					if(temp1==null)temp1=Integer.toString(joints[sons[j]].dof[k]);
					else
					   temp1= temp1+' '+Integer.toString(joints[sons[j]].dof[k]);
				}
				out1.write(temp1);
				out1.write("\r");
				temp1 = null;
				for(k=0;k<joints[sons[j]].number_dof;k++)
				{
					if(temp1==null)temp1=Float.toString(joints[sons[j]].dofc[0][k]);
					else
						temp1=temp1+" "+Float.toString(joints[sons[j]].dofc[0][k]);
					//fp.writeChars();
					//fp.writeChar(',');
				}
				if(temp1!=null)
				{ 
				   out1.write(temp1);
				   out1.write("\r");
				}
				//fp.writeChars("\r");
			 }
		  out1.write("/*******************************************************************/\r");
		out1.close();
		}
    catch (Exception e) {
      System.out.println("Some problem in data file -- aborting");
      System.out.println(e.toString());
      }
	}//the above code is for debug use
    for(i=0;i<number_son;i++)
	{
		Matrix mat1 = new Matrix();
		mat1.makeIdent();
		Matrix mat1inv = new Matrix();
		mat1inv.makeIdent();
		joints[sons[i]].mat.makeIdent();
		for(j=0;j<joints[sons[i]].number_dof;j++)
		{
		    if(joints[sons[i]].dof[j]==1)
			    joints[sons[i]].mat.postTrans(joints[sons[i]].dofc[frame][j], 0, 0);
			else if(joints[sons[i]].dof[j]==2)
			    joints[sons[i]].mat.postTrans (0,joints[sons[i]].dofc[frame][j], 0);
			else if(joints[sons[i]].dof[j]==3)
			    joints[sons[i]].mat.postTrans (0, 0, joints[sons[i]].dofc[frame][j]);
			else if(joints[sons[i]].dof[j]==4)
			    joints[sons[i]].mat.postRotZ(joints[sons[i]].dofc[frame][j]);
			else if(joints[sons[i]].dof[j]==5)
			    joints[sons[i]].mat.postRotY(joints[sons[i]].dofc[frame][j]);
			else if(joints[sons[i]].dof[j]==6)
			    joints[sons[i]].mat.postRotX(joints[sons[i]].dofc[frame][j]);
		}
		mat1.postRotX(joints[sons[i]].axis[0]);
		mat1.postRotY(joints[sons[i]].axis[1]);
		mat1.postRotZ(joints[sons[i]].axis[2]);
		mat1inv.postMult(mat1);
		mat1inv.invert();
		mat1inv.postMult(joints[sons[i]].mat);
		mat1inv.postMult(mat1);
		mat1inv.postMult(mat);
		joints[sons[i]].mat.makeIdent();
		joints[sons[i]].mat.postMult(mat1inv);
		//joints[sons[i]].mat.postMult(mat);
		mat1inv.postTrans(amc_position[frame][0],amc_position[frame][1],amc_position[frame][2]);
		for(j=0;j<3;j++)
		  pos[j] = (joints[sons[i]].direction[j])*(joints[sons[i]].length);
		joints[sons[i]].amc_position[frame] = mat1inv.xformPt(pos);

		//front_up
		for(j=0;j<3;j++)
		  pos[j] = (joints[sons[i]].dir_front_up[j]);
		joints[sons[i]].pos_front_up[frame] = mat1inv.xformPt(pos);

		//back_down
		for(j=0;j<3;j++)
		  pos[j] = (joints[sons[i]].dir_back_down[j]);
		joints[sons[i]].pos_back_down[frame] = mat1inv.xformPt(pos);

		//roottonode_left
		for(j=0;j<3;j++)
		  pos[j] = (joints[sons[i]].dir_roottonode_left[j]);
		joints[sons[i]].pos_roottonode_left[frame] = mat1inv.xformPt(pos);

		//pos_roottonode_right
		for(j=0;j<3;j++)
		  pos[j] = (joints[sons[i]].dir_roottonode_right[j]);
		joints[sons[i]].pos_roottonode_right[frame] = mat1inv.xformPt(pos);
	}
	for(i=0;i<number_son;i++)
	   joints[sons[i]].calcamcdata(joints,frame);
  }
}